/*----------------------------------------------------------------------------
 Copyright:      
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    RS232 Routinen
------------------------------------------------------------------------------*/

#ifndef _UART_H
	#define _UART_H
	
//die Prozessortaktfrequenz
//#define SYSCLK 8000000UL
#define SYSCLK 8000000UL

//----------------------------------------------------------------------------
	
	#include <avr/interrupt.h>
	#include <avr/pgmspace.h>
	#include <stdlib.h>
	#include <stdarg.h>
	#include <ctype.h>
	#include <string.h>
	#include <avr/io.h>

//----------------------------------------------------------------------------

#define USART_ECHO	1
#define BUFFER_SIZE	20

	#if defined (__AVR_ATmega8__)
		#define USR UCSRA
		#define UCR UCSRB
        #define USART_RX USART_RXC_vect 
	#endif
	
	#if defined (__AVR_ATmega88__)
		#define UCSRA UCSR0A
		#define UCSRB UCSR0B
		#define UBRRL UBRR0L
		#define UBRRH UBRR0H
		#define TXEN TXEN0
		#define RXEN RXEN0
		#define RXCIE RXCIE0
		#define UDR UDR0
		#define UDRE UDRE0
		#define USART_RX USART_RX_vect
	#endif
	
volatile unsigned char buffercounter;
char usart_rx_buffer[BUFFER_SIZE];

void usart_init(unsigned long baudrate); 
void usart_write_char(char c);
void usart_write_str(char *str);
void usart_write_P (const char *Buffer,...);
#define usart_write(format, args...)   usart_write_P(PSTR(format) , ## args)
	
//----------------------------------------------------------------------------

#endif //_UART_H

